#ifndef NODE_H
#define NODE_H

#include "cBoard.h"

class cNode {
private:
    cBoard* currentBoard;
    int currentScore;

    cBoard* possibleMoves;
    int amountOfMoves;
    cBoard* bestMove;
    int scoreOfBest;
    bool scoreSet;

    cNode** nodes;

public:
    cNode(cBoard* currentBoard, bool turn);
    ~cNode();

    int generateMoves(cBoard* currentBoard, bool turn);

    int getBestScore();
    cBoard* getBestMove();

    cBoard* getNodeBoard();
} ;

#endif
