#include <iostream>
#include <string>
#include <stdlib.h>

#include "cBoard.h"
#include "constants.h"
#include "cNode.h"

int playGame();

int main () {
    std::cout << "Boter, kaas & eieren V2.0\n";
    std::cout << "Door Bob Rubbens\n";
    std::cout << "Om het spel af te sluiten kun je altijd '88' typen.\n\n";

    playGame();

    return 0;
}

int playGame() {
    int gameLoop = 20;
    int t;
    int placeCounter = 0;
    bool turn = TURN_PLAYER;
    cBoard mainBoard(0, 0, 0, 0, 0, 0, 0, 0, 0);
    cNode* mainNode = NULL;

    std::cout << "Wie mag beginnen? 0 voor jou, 1 voor computer: ";
    std::cin >> turn;

    while (gameLoop != 88) {
        if (mainBoard.turnPossible() == false) {
            mainBoard.print();
            std::cout << "Gelijk spel!\nTyp '88' om af te sluiten";
            std::cin >> t;
            gameLoop = 88;
        } else if (mainBoard.getScore() == INT_PLAYERWIN) {
            mainBoard.print();
            std::cout << "Jij wint!\nTyp '88' om af te sluiten";
            std::cin >> t;
            gameLoop = 88;
        } else if (mainBoard.getScore() == INT_PCWIN) {
            mainBoard.print();
            std::cout << "Computer wint (haha noob)!\nTyp '88' om af te sluiten";
            std::cin >> t;
            gameLoop = 88;
        } else if (turn == TURN_PLAYER) {
            std::cout << "\nDit is het spelbord op dit moment:\n";
            mainBoard.print();
            std::cout << "Typ het nummer van het hokje waar je de O wilt plaatsen: ";
            std::cin >> gameLoop;

            placeCounter = 0;
            if (gameLoop != 88) {
                gameLoop--;
                for (int y = 0; y < 3; y++) {
                    for (int x = 0; x < 3; x++) {
                        if (placeCounter == gameLoop) {
                            if (mainBoard.getPos(x, y) > 0) {
                                std::cout << "Dat hokje is al gebruikt!\n";
                            } else {
                                mainBoard.setPos(x, y, turn);
                                turn = TURN_PC;
                            }
                            placeCounter++;
                        } else {
                            placeCounter++;
                        }
                    }
                }
            }
        } else if (turn == TURN_PC) {
            mainNode = new cNode(&mainBoard, turn);
            mainBoard.setField(mainNode->getBestMove());
            turn = TURN_PLAYER;
            std::cout << "\n";
            delete mainNode;
        }
    }

    return 0;
}
