#include "constants.h"
#include "functions.h"

int analyzeTriplet(int f, int s, int t) {
    int output = 0;

    if (f == INT_PC || s == INT_PC || t == INT_PC) {
        if (f == INT_PLAYER || s == INT_PLAYER || t == INT_PLAYER) {
            // If there are X's and O's in the triplet, they both neither get a point.
            output = INT_EMPTY;
        } else {
            if (f == INT_PC && s == INT_PC && t == INT_PC) {
                // If they are all X's, PC WINS.
                output = INT_PCWIN;
            } else {
                // If there are only X's in the triplet, the PC gets a point.
                output = INT_PC;
            }
        }
    } else if (f == INT_PLAYER || s == INT_PLAYER || t == INT_PLAYER) {
        if (f == INT_PLAYER && s == INT_PLAYER && t == INT_PLAYER) {
            output = INT_PLAYERWIN;
        } else {
            // If there are only O's and no X's in the triplet, the PLAYER gets a point.
            output = INT_PLAYER;
        }
    } else {
        // If they can both still take it, they both get a point.
        output = INT_BOTH;
    }

    return output;
}
